"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPluginConfig = void 0;
const formatter_1 = require("./formatter");
const issue_config_1 = require("./issue/issue-config");
const type_script_worker_config_1 = require("./typescript/type-script-worker-config");
function createPluginConfig(compiler, options = {}) {
    return {
        async: options.async === undefined ? compiler.options.mode === 'development' : options.async,
        typescript: type_script_worker_config_1.createTypeScriptWorkerConfig(compiler, options.typescript),
        issue: issue_config_1.createIssueConfig(compiler, options.issue),
        formatter: formatter_1.createFormatterConfig(options.formatter),
        logger: options.logger || console,
        devServer: options.devServer !== false,
    };
}
exports.createPluginConfig = createPluginConfig;
