"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rpc_1 = require("../../rpc");
const config_1 = require("./lib/config");
const dependencies_1 = require("./lib/dependencies");
const system_1 = require("./lib/system");
const getDependenciesWorker = ({ changedFiles = [], deletedFiles = [], }) => {
    system_1.system.invalidateCache();
    if (config_1.didConfigFileChanged({ changedFiles, deletedFiles })) {
        config_1.invalidateConfig();
        dependencies_1.invalidateDependencies();
    }
    else if (config_1.didRootFilesChanged()) {
        dependencies_1.invalidateDependencies();
    }
    return dependencies_1.getDependencies();
};
rpc_1.exposeRpc(getDependenciesWorker);
